diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index ff4b727cf..0191185b2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -2,6 +2,9 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
@@ -17,49 +20,80 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.useless.dragonfly.data.entity.mojang.EntityGeometryMojangData;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+import java.util.HashMap;
+import java.util.Map;
 
 public abstract class EntityRenderer<T extends Entity>
 {
-    protected EntityRenderDispatcher renderDispatcher;
+    private final @NotNull Map<@NotNull String, @NotNull StaticEntityModel> modelMap = new HashMap<>();
+    protected EntityRenderDispatcher renderDispatcher = null;
+    protected Class<? extends T> appliedClass = null;
     protected float shadowSize;
     protected float shadowOpacity;
 
     public EntityRenderer()
     {
-        shadowSize = 0.0F;
-        shadowOpacity = 1.0F;
+        this.shadowSize = 0.0F;
+        this.shadowOpacity = 1.0F;
     }
 
-    public abstract void render(Tessellator tessellator, T entity, double x, double y, double z,
+    public abstract void render(@NotNull Tessellator tessellator, @NotNull T entity, double x, double y, double z,
                                 float yaw, float partialTick);
 
-    public void renderPreview(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick) {
+    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         render(tessellator, entity, x, y, z, yaw, partialTick);
     }
 
-    protected void bindTexture(String texturePath)
+    protected void bindTexture(final @NotNull String texturePath)
     {
-        TextureManager textureManager = renderDispatcher.textureManager;
+        final TextureManager textureManager = this.renderDispatcher.textureManager;
         textureManager.bindTexture(textureManager.loadTexture(texturePath));
     }
-    public boolean bindDownloadableTexture(String urlTexture, String backupTexture, ImageParser imageParser) {
-        return renderDispatcher.textureManager.bindDownloadableTexture(urlTexture, backupTexture, imageParser);
+    public boolean bindDownloadableTexture(final String urlTexture, final String backupTexture, final ImageParser imageParser) {
+        return this.renderDispatcher.textureManager.bindDownloadableTexture(urlTexture, backupTexture, imageParser);
+    }
+
+    protected @NotNull StaticEntityModel getModel(@NotNull final String localId) {
+        StaticEntityModel model = this.modelMap.get(localId);
+        if (model != null) {
+            return model;
+        }
+        final NamespaceID id = EntityDispatcher.idForClass(this.appliedClass);
+        if (id != null) {
+            model = EntityGeometryMojangData.Cache.getModelForEntity(id, localId);
+        } else {
+            model = EntityGeometryMojangData.Cache.getFallbackModel();
+        }
+        this.modelMap.put(localId, model);
+        return model;
+    }
+
+    public final @NotNull EntityRenderer<T> setModel(@NotNull final String localId, @NotNull final String modelId, final double inflation) {
+        this.modelMap.put(localId, EntityGeometryMojangData.Cache.getModel(modelId, inflation));
+        return this;
+    }
+
+    public void onWorldChanged(final @NotNull World world)
+    {
     }
     
-    private void renderFire(Tessellator tessellator, T entity, double x, double y, double z, float partialTick)
+    private void renderFire(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float partialTick)
     {
         GL11.glDisable(GL11.GL_LIGHTING);
-        IconCoordinate texture = TextureRegistry.getTexture("minecraft:block/fire");
+        final IconCoordinate texture = TextureRegistry.getTexture("minecraft:block/fire");
         texture.parentAtlas.bind();
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
-        float f9 = entity.bbWidth * 1.4F;
+        final float f9 = entity.bbWidth * 1.4F;
         GL11.glScalef(f9, f9, f9);
         float f10 = 0.5F;
-        float f11 = 0.0F;
+        final float f11 = 0.0F;
         float f12 = entity.bbHeight;
         float f13 = (float)(entity.y - entity.bb.minY);
-        GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
+        GL11.glRotatef(-this.renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
         GL11.glTranslatef(0.0F, 0.0F, -0.3F + (float)(int)f12 * 0.02F);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         if(LightmapHelper.isLightmapEnabled()) {
@@ -74,11 +108,11 @@ public abstract class EntityRenderer<T extends Entity>
         {
             double f2 = texture.getIconUMin();
             double f4 = texture.getIconUMax();
-            double f6 = texture.getIconVMin();
-            double f8 = texture.getIconVMax();
+            final double f6 = texture.getIconVMin();
+            final double f8 = texture.getIconVMax();
             if((l / 2) % 2 == 0)
             {
-                double f15 = f4;
+                final double f15 = f4;
                 f4 = f2;
                 f2 = f15;
             }
@@ -97,27 +131,27 @@ public abstract class EntityRenderer<T extends Entity>
         GL11.glEnable(GL11.GL_LIGHTING);
     }
 
-    private void renderShadow(Tessellator tessellator, T entity, double posX, double posY, double posZ,
-                              float opacity, float partialTick)
+    private void renderShadow(final @NotNull Tessellator tessellator, @NotNull final T entity, final double posX, final double posY, final double posZ,
+                              final float opacity, final float partialTick)
     {
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        TextureManager textureManager = renderDispatcher.textureManager;
+        final TextureManager textureManager = this.renderDispatcher.textureManager;
         textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/shadow.png"));
-        World world = getWorld();
+        final World world = entity.world;
         GL11.glDepthMask(false);
-        double lerpX = entity.xo + (entity.x - entity.xo) * (double)partialTick;
-        double lerpY = entity.yo + (entity.y - entity.yo) * (double)partialTick + (double)entity.getShadowHeightOffs();
-        double lerpZ = entity.zo + (entity.z - entity.zo) * (double)partialTick;
-        int minX = MathHelper.floor(lerpX - (double)shadowSize);
-        int maxX = MathHelper.floor(lerpX + (double)shadowSize);
-        int minY = MathHelper.floor(lerpY - (double)shadowSize);
-        int maxY = MathHelper.floor(lerpY);
-        int minZ = MathHelper.floor(lerpZ - (double)shadowSize);
-        int maxZ = MathHelper.floor(lerpZ + (double)shadowSize);
-        double dxLerp = posX - lerpX;
-        double dyLerp = posY - lerpY;
-        double dzLerp = posZ - lerpZ;
+        final double lerpX = entity.xo + (entity.x - entity.xo) * (double)partialTick;
+        final double lerpY = entity.yo + (entity.y - entity.yo) * (double)partialTick + (double)entity.getShadowHeightOffs();
+        final double lerpZ = entity.zo + (entity.z - entity.zo) * (double)partialTick;
+        final int minX = MathHelper.floor(lerpX - (double) this.shadowSize);
+        final int maxX = MathHelper.floor(lerpX + (double) this.shadowSize);
+        final int minY = MathHelper.floor(lerpY - (double) this.shadowSize);
+        final int maxY = MathHelper.floor(lerpY);
+        final int minZ = MathHelper.floor(lerpZ - (double) this.shadowSize);
+        final int maxZ = MathHelper.floor(lerpZ + (double) this.shadowSize);
+        final double dxLerp = posX - lerpX;
+        final double dyLerp = posY - lerpY;
+        final double dzLerp = posZ - lerpZ;
         tessellator.startDrawingQuads();
 
         for(int blockX = minX; blockX <= maxX; blockX++)
@@ -126,10 +160,10 @@ public abstract class EntityRenderer<T extends Entity>
             {
                 for(int blockZ = minZ; blockZ <= maxZ; blockZ++)
                 {
-                    int blockId = world.getBlockId(blockX, blockY - 1, blockZ);
+                    final int blockId = world.getBlockId(blockX, blockY - 1, blockZ);
                     if(blockId > 0 && world.getBlockLightValue(blockX, blockY, blockZ) > 3)
                     {
-                        renderShadowOnBlock(tessellator, entity, Blocks.blocksList[blockId], posX, posY + (double)entity.getShadowHeightOffs(), posZ, blockX, blockY, blockZ, opacity, shadowSize, dxLerp, dyLerp + (double)entity.getShadowHeightOffs(), dzLerp);
+                        renderShadowOnBlock(tessellator, entity, Blocks.blocksList[blockId], posX, posY + (double)entity.getShadowHeightOffs(), posZ, blockX, blockY, blockZ, opacity, this.shadowSize, dxLerp, dyLerp + (double)entity.getShadowHeightOffs(), dzLerp);
                     }
                 }
 
@@ -142,20 +176,15 @@ public abstract class EntityRenderer<T extends Entity>
         GL11.glDepthMask(true);
     }
 
-    private World getWorld()
-    {
-        return renderDispatcher.world;
-    }
-
-    private void renderShadowOnBlock(Tessellator tessellator, T entity, Block<?> block, double d, double d1, double d2,
-                                     int x, int y, int z, float opacity, float size, double xo,
-                                     double yo, double zo)
+    private void renderShadowOnBlock(final @NotNull Tessellator tessellator, final @NotNull T entity, final @NotNull Block<?> block, final double d, final double d1, final double d2,
+                                     final int x, final int y, final int z, final float opacity, final float size, final double xo,
+                                     final double yo, final double zo)
     {
         if(!block.isCubeShaped())
         {
             return;
         }
-        double brightness = getWorld().getLightBrightness(x, y, z);
+        double brightness = entity.world.getLightBrightness(x, y, z);
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
         double alpha = ((double)opacity - (d1 - ((double)(y + 1) + yo)) / 2D) * 0.5D * brightness;
         if(alpha < 0.0D)
@@ -167,112 +196,109 @@ public abstract class EntityRenderer<T extends Entity>
             alpha = 1.0D;
         }
         tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, (float)alpha);
-        AABB aabb = block.getCollisionBoundingBoxFromPool(getWorld(), x, y, z);
+        final AABB aabb = block.getCollisionBoundingBoxFromPool(entity.world, x, y, z);
         if(aabb == null) {
         	return;
         }
-        double xMin = aabb.minX + xo;
-        double xMax = aabb.maxX + xo;
-        double yMin = aabb.maxY + yo + 0.015625D - 1;
-        double zMin = aabb.minZ + zo;
-        double zMax = aabb.maxZ + zo;
-        float f2 = (float)((d - xMin) / 2D / (double)size + 0.5D);
-        float f3 = (float)((d - xMax) / 2D / (double)size + 0.5D);
-        float f4 = (float)((d2 - zMin) / 2D / (double)size + 0.5D);
-        float f5 = (float)((d2 - zMax) / 2D / (double)size + 0.5D);
+        final double xMin = aabb.minX + xo;
+        final double xMax = aabb.maxX + xo;
+        final double yMin = aabb.maxY + yo + 0.015625D - 1;
+        final double zMin = aabb.minZ + zo;
+        final double zMax = aabb.maxZ + zo;
+        final float f2 = (float)((d - xMin) / 2D / (double)size + 0.5D);
+        final float f3 = (float)((d - xMax) / 2D / (double)size + 0.5D);
+        final float f4 = (float)((d2 - zMin) / 2D / (double)size + 0.5D);
+        final float f5 = (float)((d2 - zMax) / 2D / (double)size + 0.5D);
         tessellator.addVertexWithUV(xMin, yMin, zMin, f2, f4);
         tessellator.addVertexWithUV(xMin, yMin, zMax, f2, f5);
         tessellator.addVertexWithUV(xMax, yMin, zMax, f3, f5);
         tessellator.addVertexWithUV(xMax, yMin, zMin, f3, f4);
     }
 
-    public static void renderOffsetAABB(Tessellator tessellator, AABB axisalignedbb, double d, double d1, double d2)
+    public static void renderOffsetAABB(final @NotNull Tessellator tessellator, final @NotNull AABB aabb, final double x, final double y, final double z)
     {
         GL11.glDisable(GL11.GL_TEXTURE_2D);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         tessellator.startDrawingQuads();
-        tessellator.setTranslation(d, d1, d2);
+        tessellator.setTranslation(x, y, z);
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.maxZ);
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.maxZ);
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.maxZ);
         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
         tessellator.draw();
         GL11.glEnable(GL11.GL_TEXTURE_2D);
     }
 
-    public static void renderFlatAABB(AABB axisalignedbb)
+    public static void renderFlatAABB(final @NotNull AABB aabb)
     {
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.maxZ);
         tessellator.draw();
     }
 
-    public void init(EntityRenderDispatcher dispatcher)
+    public void init(@NotNull final Class<? extends T> appliedClass, final @NotNull EntityRenderDispatcher dispatcher)
     {
         this.renderDispatcher = dispatcher;
+        this.appliedClass = appliedClass;
     }
 
-    public void onUnload() {
-
-    }
-
-    public void postRender(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick)
+    public void postRender(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick)
     {
-        if(renderDispatcher.gameSettings != null && (renderDispatcher.gameSettings.fancyGraphics.value == 1 && shadowSize > 0.0F))
+        if(this.renderDispatcher.settings.fancyGraphics.value == 1 && this.shadowSize > 0.0F)
         {
-            double distance = renderDispatcher.distanceToLerpSquared(entity.x, entity.y, entity.z);
-            float opacity = (float)((1.0D - distance / 256D) * (double) shadowOpacity);
+            final double distance = this.renderDispatcher.distanceToLerpSquared(entity.x, entity.y, entity.z);
+            final float opacity = (float)((1.0D - distance / 256D) * (double) this.shadowOpacity);
             if(opacity > 0.0F)
             {
                 renderShadow(tessellator, entity, x, y, z, opacity, partialTick);
@@ -284,8 +310,12 @@ public abstract class EntityRenderer<T extends Entity>
         }
     }
 
-    public FontRenderer getFont()
+    public @NotNull FontRenderer getFont()
     {
-        return renderDispatcher.getFont();
+        return this.renderDispatcher.font;
+    }
+
+    public @NotNull AABB entityViewBox(@NotNull final T entity) {
+        return entity.bb;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
index 0996f594e..7998bd015 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
@@ -3,13 +3,14 @@ package net.minecraft.client.render.entity;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
 public class EntityRendererArrow extends EntityRenderer<ProjectileArrow>
 {
     @Override
-    public void render(Tessellator tessellator, ProjectileArrow arrow, double x, double y, double z,
+    public void render(@NotNull Tessellator tessellator, @NotNull ProjectileArrow arrow, double x, double y, double z,
                        float yaw, float partialTick) {
         bindTexture("/assets/minecraft/textures/entity/arrows.png");
         GL11.glPushMatrix();
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
index d53a766c6..5ecdc0d13 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
@@ -2,37 +2,39 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.model.ModelBoat;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.tileentity.TileEntityRendererFlag;
+import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.wind.WindProvider;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
 public class EntityRendererBoat extends EntityRenderer<EntityBoat>
 {
-	
-	private final Minecraft mc = Minecraft.getMinecraft();
 
-    public EntityRendererBoat()
-    {
-        shadowSize = 0.5F;
-        modelBoat = new ModelBoat();
-        flagRenderer.setRenderDispatcher(TileEntityRenderDispatcher.instance);
+    private final TileEntityRendererFlag flagRenderer;
+    private final Minecraft mc = Minecraft.getMinecraft();
+
+    public EntityRendererBoat() {
+        super();
+        this.shadowSize = 0.5F;
+        this.flagRenderer = (TileEntityRendererFlag) (Object) TileEntityRenderDispatcher.instance.getRenderer(TileEntityFlag.class); // Definitely safe casting :)
     }
 
     @Override
-    public void render(Tessellator tessellator, EntityBoat entity, double x, double y, double z,
-                       float yaw, float partialTick)
+    public void render(@NotNull final Tessellator tessellator, @NotNull final EntityBoat entity, final double x, final double y, final double z,
+                       final float yaw, final float partialTick)
     {
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
         GL11.glRotatef(180F - yaw, 0.0F, 1.0F, 0.0F);
-        float hurt = (float)entity.boatTimeSinceHit - partialTick;
+        final float hurt = (float)entity.boatTimeSinceHit - partialTick;
         float dmg = (float)entity.boatCurrentDamage - partialTick;
         if(dmg < 0.0F)
         {
@@ -44,29 +46,28 @@ public class EntityRendererBoat extends EntityRenderer<EntityBoat>
         }
         if (entity.tileEntityFlag != null)
         {
-            World theWorld = mc.currentWorld;
-            WindProvider theWind = theWorld.getWorldType().getWindManager();
+            final World theWorld = this.mc.currentWorld;
+            final WindProvider theWind = theWorld.getWorldType().getWindManager();
 
-            float windAngle = theWind.getWindDirection(theWorld, (float) x, (float) y, (float) z) * 360f + (180 - yaw);
-            float boatAngle = 180;
+            final float windAngle = theWind.getWindDirection(theWorld, (float) x, (float) y, (float) z) * 360f + (180 - yaw);
+            final float boatAngle = 180;
 
             // If boat speed is 0, windAngle is 100% and boatAngle is 0%
             // If boat speed is > 3, windAngle is 0% and boatAngle is 100%
-            float boatSpeed = MathHelper.sqrt_float((float) (entity.xd * entity.xd + entity.zd * entity.zd));
-            float angle = MathHelper.lerp(windAngle, boatAngle, (float)MathHelper.clamp(boatSpeed, 0, 0.25) * 4);
+            final float boatSpeed = MathHelper.sqrt_float((float) (entity.xd * entity.xd + entity.zd * entity.zd));
+            final float angle = MathHelper.lerp(windAngle, boatAngle, (float)MathHelper.clamp(boatSpeed, 0, 0.25) * 4);
 
-            flagRenderer.doRender(entity.tileEntityFlag, -1.19, 0.187, -0.5, partialTick, false, angle, 1.0f);
+            this.flagRenderer.doRender(tessellator, entity.tileEntityFlag, -1.19, 0.187, -0.5, partialTick, false, angle, 1.0f);
         }
         TextureRegistry.blockAtlas.bind();
-        float f4 = 0.75F;
+        final float f4 = 0.75F;
         GL11.glScalef(f4, f4, f4);
         GL11.glScalef(1.0F / f4, 1.0F / f4, 1.0F / f4);
         bindTexture("/assets/minecraft/textures/entity/boat.png");
-        GL11.glScalef(-1F, -1F, 1.0F);
-        modelBoat.render(null, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F, partialTick);
+        GL11.glScalef(1/16f, 1/16f, -1/16f);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        getModel("main").render(tessellator);
         GL11.glPopMatrix();
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
-
-    protected ModelBase modelBoat;
-    private TileEntityRendererFlag flagRenderer = new TileEntityRendererFlag();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
index b10c0a198..4210664ab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
@@ -1,31 +1,25 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.model.ModelCannonball;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.projectile.ProjectileCannonball;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 public class EntityRendererCannonball extends EntityRenderer<ProjectileCannonball>
 {
 
-    protected ModelBase modelCannonball;
-
-    public EntityRendererCannonball()
-    {
-        modelCannonball = new ModelCannonball();
+    public EntityRendererCannonball() {
+        super();
     }
 
     @Override
-    public void render(Tessellator tessellator, ProjectileCannonball entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
+    public void render(@NotNull final Tessellator tessellator, @NotNull final ProjectileCannonball entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
-        GL11.glRotatef(180F - yaw, 0.0F, 1.0F, 0.0F);
+        GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
         bindTexture("/assets/minecraft/textures/entity/cannonball.png");
-        GL11.glScalef(-1F, -1F, 1.0F);
-        modelCannonball.render(null, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.03125F, partialTick);
+        GL11.glScalef(1/MobRenderer.ENTITY_RENDER_SCALE, 1/MobRenderer.ENTITY_RENDER_SCALE, -1/MobRenderer.ENTITY_RENDER_SCALE);
+        getModel("main").render(tessellator);
         GL11.glPopMatrix();
     }
 }
\ No newline at end of file
